import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class uman here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Uman extends Actor
{
    private int speed = 7;
    private int jumpspeed = 4;
    private int vSpeed = 0;
    private int acceleration = 1;
    private int upSpeed;
    public int sequence = 0;  
    private int springtimer;
    private int delay = 0;
    public boolean facingLeft;
    public int soundDelay = 1;
    private int countor = 0;
    private GreenfootSound song = new GreenfootSound("access.wav");  
  
    public GreenfootImage stand = new GreenfootImage("Player_groot.png");  
    public GreenfootImage walk1 = new GreenfootImage("Player_walk1.png");  
    public GreenfootImage walk2 = new GreenfootImage("Player_walk2.png");
    public GreenfootImage walk3 = new GreenfootImage("Player_walk3.png");
    public GreenfootImage walk4 = new GreenfootImage("Player_walk4.png");
    public GreenfootImage standWhere = new GreenfootImage("Player_groot.png");     
    
     public GreenfootImage standl = new GreenfootImage("Player_grootl.png");  
    public GreenfootImage walk1l = new GreenfootImage("Player_walk1l.png");  
    public GreenfootImage walk2l = new GreenfootImage("Player_walk2l.png");
    public GreenfootImage walk3l = new GreenfootImage("Player_walk3l.png");
    public GreenfootImage walk4l = new GreenfootImage("Player_walk4l.png");
    
    public void act() 
    {
        checkCollision();
        if(springtimer > 0)
        {
            springtimer--;
        }
        
        if(intersect4())
        {
            vSpeed= 0;
        }        
        else if(intersect3())
        {
            gravityUp();
        }
        else
        {
            jump();
            checkFall();
        }
        animator();
        checkShoot();
    } 
    
     private void sound()
    {
        if(onGround())
        {
            countor++;
        }
        if(countor == 1)
        {
            Greenfoot.playSound("Bass01.wav");
        }
        
    }
    
    private void imageChanger()
    {
        if (Greenfoot.isKeyDown("left"))
        { 
            setImage("Player_groot_links.png");
        }
        if (Greenfoot.isKeyDown("right"))
        {
            setImage("Player_groot_rechts.png");
        }
    }
    
    private void animator()      
    {      
        if (Greenfoot.isKeyDown("right"))      
        {       
            sequence++;      
            standWhere = stand;  
            facingLeft = false;
            switch (sequence)      
            {      
                case 1: setImage(walk1); break;      
                case 6: setImage(stand); break;      
                case 11: setImage(walk2); break;      
                case 16: setImage(walk3); break;
                case 20: setImage(walk4); break;
                case 25: sequence = 0; break;
            }      
        }
        else if (Greenfoot.isKeyDown("left"))      
        {       
            sequence++;    
            facingLeft = true;
            standWhere =  standl;   
            switch (sequence)  
            {      
                case 1: setImage(walk1l); break;      
                case 6: setImage(standl); break;      
                case 11: setImage(walk2l); break;      
                case 16: setImage(walk3l); break;
                case 20: setImage(walk4l); break;
                case 25: sequence = 0; break;
            }      
        }     
        else
        {
            setImage(standWhere);   
        }    
    }  
       
   public void jump()
    {
        if(Greenfoot.isKeyDown("z") && springtimer == 0)
        {
            if (onGround() || onGround2() || onGround3() || onGround4())
            {
                vSpeed = -12;
                gravityDown();
                springtimer = 25;
            }
            countor = 0;
        }
        
    }
    
    public void checkFall()
    {
        if (onGround() || onGround2() || onGround3() || onGround4()){
            vSpeed = 0;
        }
        else 
        { 
            gravityDown();
        }
    }
    
    public void gravityUp()
    {
            setLocation ( getX(), getY() + vSpeed);
            if(vSpeed >= -13)
            {
                vSpeed--;
            }
    }
    
    public void gravityDown()
    {
        setLocation ( getX(), getY() + vSpeed);
        if(vSpeed <= 15)
        {
            vSpeed++;
        }
    }
    
    public boolean onGround()
    {
        Actor Under = getOneObjectAtOffset (0, getImage().getHeight() / 2 + 2, ZwarteBalk.class);
        return Under != null;
    }
    
    public boolean onGround2()
    {
        Actor Under = getOneObjectAtOffset (0, getImage().getHeight() / 2 + 2, RodeBalk.class);
        return Under != null;
    }
    
    public boolean onGround3()
    {
        Actor Under = getOneObjectAtOffset (0, getImage().getHeight() / 2 + 2, BrokenL.class);
        return Under != null;
    }
    
    public boolean onGround4()
    {
        Actor Under = getOneObjectAtOffset (0, getImage().getHeight() / 2 + 2, BrokenR.class);
        return Under != null;
    }
    
    public boolean intersect1()
     {
        Actor uman = getOneIntersectingObject(WallRechts.class);
        if (uman == null) 
        {
            return false;
        }
        else { 
            return true;
        }
    }
    
    public boolean intersect2()
     {
        Actor uman = getOneIntersectingObject(WallLinks.class);
        if (uman == null) 
        {
            return false;
        }
        else { 
            return true;
        }
    }
     
     public boolean intersect3()
     {
        Actor uman = getOneIntersectingObject(GravityUp.class);
        if (uman == null) 
        {
            return false;
        }
        else { 
            return true;
        }
     }
    
     public boolean intersect4()
     {
        Actor uman = getOneIntersectingObject(Magnet.class);
            if (uman == null) 
            {
                return false;
            }
            else { 
                return true;
            }
            
     }
     
    public boolean intersect5()
     {
        Actor uman = getOneIntersectingObject(ZwarteBalk.class);
        if (uman == null) 
        {
            return false;
        }
        else { 
            return true;
        }
     }
     
    public boolean intersect6()
    {
        Actor uman = getOneIntersectingObject(Knop.class);
            if (uman == null) 
            {
                return false;
            }
            else {
                return true;
            }
            
    }
    
    public boolean intersect7()
    {
        Actor uman = getOneIntersectingObject(StuffStopper.class);
            if (uman == null) 
            {
                return false;
            }
            else {
                return true;
            }
            
    }
    
    public boolean intersect8()
    {
        Actor uman = getOneIntersectingObject(StuffStopper2.class);
            if (uman == null) 
            {
                return false;
            }
            else {
                return true;
            }
            
    }
    
    public boolean intersect9()
    {
        Actor uman = getOneIntersectingObject(Enemy1.class);
            if (uman == null) 
            {
                return false;
            }
            else {
                return true;
            }
            
    }
    
    public void checkCollision()
    {
        int originalX = getX();
        int originalY = getY();
        if(intersect1())
        {
            setLocation(originalX-7, originalY);
        }
        if(intersect2())
        {
            setLocation(originalX+7, originalY);    
        }
        if(intersect5())
        {
            setLocation(originalX, originalY-7);
        }
        if(intersect7())
        {
            Greenfoot.setWorld(new Death());
        }
        if(intersect8())
        {
            Greenfoot.setWorld(new Death2());
        }
        if(intersect9())
        {
            Greenfoot.setWorld(new Death2());
        }
    }
    
    private void checkShoot()
    {
       if(delay>0)
       {
         delay = delay -1;
        }
        
       else if(Greenfoot.isKeyDown("space"))
       {
           fire();
           delay = 30;
        }
    }

     private void fire()
    {
        getWorld().addObject(new Beam(facingLeft == true), getX() + 3, getY() -26);
   }
}
